<!DOCTYPE html>
<html
        lang="en"
        xmlns:th="http://www.thymeleaf.org"
        xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
        xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
        layout:decorate="~{layout3}"
>
<head>
    <meta charset="UTF-8" />
    <title>Program Studi</title>
</head>
<body>

<main
        layout:fragment="main"
        class="container-xxl bd-gutter mt-3 my-md-4 bd-layout"
>
    <div th:include="sidebar/sidebar_masterdata::sidebar_masterdata" th:remove="tag">
        sidebar
    </div>


    <main class="bd-main-xxl">
        <div class="row">
            <div class="col-md-12">
                <div class="h4 pb-2 mb-4 text-dark border-bottom border-dark">
                    <i class="fa fa-circle text-secondary" ></i> Program Studi
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-md-12">
                <div class="alert alert-success mb-3" role="alert" th:if="${berhasil != null}">
                    <i class="fa fa-check"></i> <span th:text="${berhasil}"></span>
                </div>
                <div class="card shadow-sm border-0">
                    <div class="card-header p-4">
                        <div class="d-flex justify-content-between">
                            <span class="fw-bold text-secondary">Daftar Program Studi</span>
                            <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal" data-bs-target="#prodiModal">
                                Tambah Program Studi
                            </button>
                        </div>
                    </div>
                    <div class="card-body pt-4 pb-0 border-0">
                        <form method="get">
                            <div class="row">

                                <div class="col-md-9">
                                    Show entries <span sd:page-size-selector="javascript"></span>
                                </div>

                                <div class="col-md-3" align="right">
                                    <input
                                            class="form-control me-2"
                                            type="text"
                                            placeholder="Search"
                                            name="search"
                                            th:value="${search}"
                                            aria-label="Search"
                                    />
                                    <!--                <button class="btn btn-danger" type="submit" style="background-color: #15408d; border-color:#15408d">Log out</button>-->
                                </div>

                            </div>
                            <br />
                        </form>
                    </div>

                    <div class="card-body p-0 pb-0">
                        <div class="table-responsive mb-0">
                            <table class="table table-striped table-hover small mb-0">
                                <thead>
                                <tr>
                                    <th class="pt-3 pb-3 border-dark border-start-0 border-end-0 text-end" scope="col" style="width: 10px">#</th>
                                    <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Kode</th>
                                    <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Program Studi</th>
                                    <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Fakultas</th>
                                    <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col">Departemen</th>
                                    <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col" style="width: 40px"></th>
                                    <th class="pt-3 pb-3 border-dark border-start-0 border-end-0" scope="col" style="width: 40px"></th>
                                </tr>
                                </thead>
                                <tbody class="align-middle">
                                <tr th:each="dataProdi,row : ${listProdi}">
                                    <td class="border-start-0 border-end-0 text-end" th:text="${(row.index + 1) + (listProdi.number * listProdi.size)+'.'}">1.</td>
                                    <td class="border-start-0 border-end-0" >
                                        <span th:text="${dataProdi.getKodeProdi()}"></span>
                                    </td>
                                    <td class="border-start-0 border-end-0">
                                        <span th:text="${dataProdi.getNamaProdi()+' ('+ dataProdi.getNamaProdiEnglish()+')'}"></span>
                                    </td>
                                    <td class="border-start-0 border-end-0">
                                        <span th:text="${dataProdi.getFakultas().getNamaFakultas()}"></span>
                                    </td>
                                    <td class="border-start-0 border-end-0">
                                        <span th:text="${dataProdi.getDepartment().getDepartmentName()}"></span>
                                    </td>
                                    <td class="border-start-0 border-end-0">
                                        <button type="button" class="btn btn-primary btn-sm" data-bs-toggle="modal"
                                                data-bs-target="#prodiModal" th:data-id="${dataProdi.getId()}" onclick="loadProdiData(this)">
                                            <i class="fa fa-edit"></i>
                                        </button>
                                    </td>
                                    <td class="border-start-0 border-end-0">
                                        <form method="post" th:action="@{/masterdata/prodi/delete(prodi=${dataProdi.id},search = ${search}, page = ${page.getPageNumber()}, size = ${size})}">
                                            <button type="submit" class="btn btn-danger btn-sm"
                                                    onclick="return confirm('Are you sure want to delete this?')">
                                                <i class="fa fa-trash"></i>
                                            </button>
                                        </form>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>

                    <div class="card-footer text-end p-4 bg-body border-top-0">
                        <nav aria-label="Page navigation example">
                            <ul class="pagination" sd:pagination="full"></ul>
                        </nav>
                    </div>
                </div>
            </div>
        </div>

        <div class="modal fade" id="prodiModal" tabindex="-1" aria-labelledby="prodiModalLabel" aria-hidden="true">

            <div class="modal-dialog modal-lg modal-dialog-centered">
                <div class="modal-content">
                    <div class="modal-header bg-primary text-light">
                        <h5 class="modal-title" id="prodiModalLabel"><i class="fa fa-edit text-secondary"></i> Form fakultas</h5>
                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                    </div>
                    <form class="form-horizontal" th:action="@{/masterdata/prodi/save}" th:object="${prodi}" method="post" enctype="multipart/form-data">
                        <div class="modal-body">
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="fakultas" class="form-label text-secondary">Fakultas</label>
                                        <select class="form-select" id="fakultas" aria-label="Default select example" th:field="*{fakultas}">
                                            <option th:each="data : ${listFakultas}"
                                                    th:text="${data.getNamaFakultas()+'('+data.getNamaFakultasEnglish()+')'}"
                                                    th:value="${data.getId()}">sdasd</option>
                                        </select>
                                        <div th:if="${#fields.hasErrors('fakultas')}" class="error-message" th:errors="*{fakultas}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="kodeProdi" class="form-label text-secondary">Kode</label>
                                        <input type="text" class="form-control" id="kodeProdi" th:field="*{kodeProdi}">
                                        <div th:if="${#fields.hasErrors('kodeProdi')}" class="error-message" th:errors="*{kodeProdi}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="namaProdi" class="form-label text-secondary">Nama</label>
                                        <input type="text" class="form-control" id="namaProdi" th:field="*{namaProdi}">
                                        <div th:if="${#fields.hasErrors('namaProdi')}" class="error-message" th:errors="*{namaProdi}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="namaProdiEnglish" class="form-label text-secondary">Nama (English)</label>
                                        <input type="text" class="form-control" id="namaProdiEnglish" th:field="*{namaProdiEnglish}">
                                        <div th:if="${#fields.hasErrors('namaProdiEnglish')}" class="error-message" th:errors="*{namaProdiEnglish}" style="color: red;"></div>
                                    </div>
                                </div>
                                <div class="col-md-6">
                                    <div class="mb-3">
                                        <label for="department" class="form-label text-secondary">Departemen terkait</label>
                                        <select class="form-select" id="department" aria-label="Default select example" th:field="*{department}">
                                            <option th:each="data : ${listDepartment}"
                                                    th:text="${data.getDepartmentName()}"
                                                    th:value="${data.getId()}">sdasd</option>
                                        </select>
                                        <div th:if="${#fields.hasErrors('department')}" class="error-message" th:errors="*{department}" style="color: red;"></div>
                                    </div>

                                    <input type="hidden" name="search" th:value="${search}">
                                    <input class="form-control" type="hidden" name="id" id="idFakultas" th:field="*{id}">
                                    <input type="hidden" name="page" th:value="${page}">
                                    <input type="hidden" name="size" th:value="${size}">
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer p-3">
                            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
                            <button type="submit" class="btn btn-primary">Save</button>
                        </div>
                    </form>
                </div>

            </div>

        </div>
    </main>
</main>
</body>
</html>

<script>
    $('#prodiModal').on('shown.bs.modal', function () {
        // Inisialisasi Select2 untuk 'fakultas' setelah modal ditampilkan
        $('#fakultas').select2({
            theme: "bootstrap-5",
            width: '100%',  // Set width to 100% explicitly
            placeholder: 'Pilih Fakultas',  // Tambahkan placeholder
            dropdownParent: $('#prodiModal')  // Pastikan dropdown berada di dalam modal
        });

        // Inisialisasi Select2 untuk 'department' setelah modal ditampilkan
        $('#department').select2({
            theme: "bootstrap-5",
            width: '100%',  // Set width to 100% explicitly
            placeholder: 'Pilih Department',  // Tambahkan placeholder
            dropdownParent: $('#prodiModal')  // Pastikan dropdown berada di dalam modal
        });
    });
</script>

<script>
    $(document).ready(function() {
        var hasErrors = $('.error-message').length > 0; // Memeriksa jika ada elemen dengan kelas error-message
        console.log("Has Errors:", hasErrors); // Menampilkan apakah ada error
        if (hasErrors) {
            console.log("Showing modal"); // Menampilkan pesan di console
            $('#prodiModal').modal('show');
        }
    });
</script>
<script>

    // Load KPI data ke modal saat ingin mengedit
    function loadProdiData(button) {
        const id = $(button).data('id');
        const modal = $('#prodiModal');  // Define the modal reference

        $.ajax({
            url: '/masterdata/prodi/data/' + id,
            method: 'GET',
            success: function(response) {
                // Mengisi data ke dalam textarea dan input yang sesuai
                modal.find('#fakultas').val(response.fakultas.id);
                modal.find('#kodeProdi').val(response.kodeProdi);
                modal.find('#namaProdi').val(response.namaProdi);
                modal.find('#namaProdiEnglish').val(response.namaProdiEnglish);
                modal.find('#department').val(response.department.id);
                modal.find('#idFakultas').val(response.id);
                modal.modal('show');  // Menampilkan modal setelah data diambil

                // Inisialisasi Select2 setelah modal ditampilkan
                modal.find('#department').select2({
                    theme: "bootstrap-5",
                    width: '100%',
                    dropdownParent: modal,  // Proper dropdownParent set to the modal
                    //allowClear: true,       // Allows clearing the selection
                    placeholder: "Pilih Department",  // Placeholder untuk select
                    minimumResultsForSearch: 1  // Enables search when there is at least 1 option
                });
                modal.find('#fakultas').select2({
                    theme: "bootstrap-5",
                    width: '100%',
                    dropdownParent: modal,  // Proper dropdownParent set to the modal
                    //allowClear: true,       // Allows clearing the selection
                    placeholder: "Pilih Fakultas",  // Placeholder untuk select
                    minimumResultsForSearch: 1  // Enables search when there is at least 1 option
                });
            },
            error: function(error) {
                console.error("Error fetching Department data:", error);
            }
        });
    }


    $('#prodiModal').on('hidden.bs.modal', function() {
        // $(this).find('textarea, input, select').val(''); // Clear all textareas, inputs, and selects

        $(this).find('.form-control').val('');
        $(this).find('.form-select').val('');
        $('.error-message').empty();
    });


</script>





